HanMacWrdKParser Class Referencefinal

the main class to read a HanMac Word-K file More...

`#include <HanMacWrdKParser.hxx>`

Inheritance diagram for HanMacWrdKParser:

## Public Member Functions

| HanMacWrdKParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~HanMacWrdKParser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGTextInterface *documentInterface) final
| virtual function used to parse the input
Public Member Functions inherited from MWAWTextParser
| ~MWAWTextParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions

void | init ()
| inits all internal variables
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document
bool | createZones ()
| finds the different objects zones
MWAWVec2f | getPageLeftTop () const
| returns the page left top point ( in inches)
void | newPage (int number)
| adds a new page
bool | sendText (long id, long subId, MWAWListenerPtr listener=MWAWListenerPtr())
| send a text zone
bool | canSendTextAsGraphic (long id, long subId)
| check if we can send a textzone as graphic
bool | sendZone (long zId)
| send a zone
bool | getColor (int colId, int patternId, MWAWColor &color) const
| returns the color associated with a pattern
bool | readZonesList ()
| try to read the zones list
bool | readZone (std::shared_ptr< HanMacWrdKZone > zone)
| try to read a generic zone
std::shared_ptr< HanMacWrdKZone > | decodeZone (std::shared_ptr< HanMacWrdKZone > zone)
| try to decode a zone
bool | readFramesUnkn (std::shared_ptr< HanMacWrdKZone > zone)
| try to read a zone storing a list of ?
bool | readPrintInfo (HanMacWrdKZone &zone)
| try to read a printinfo zone (type 7)
bool | readZone6 (std::shared_ptr< HanMacWrdKZone > zone)
| try to read a unknown zone of type 6
bool | readZone8 (std::shared_ptr< HanMacWrdKZone > zone)
| try to read a unknown zone of type 8
bool | readZonea (std::shared_ptr< HanMacWrdKZone > zone)
| try to read a unknown zone of type a
bool | readZoneb (HanMacWrdKZone &zone)
| try to read a unknown zone of type b
bool | readZonec (std::shared_ptr< HanMacWrdKZone > zone)
| try to read a unknown zone of type c
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWTextParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes

std::shared_ptr< HanMacWrdKParserInternal::State > | m_state
| the state
std::shared_ptr< HanMacWrdKGraph > | m_graphParser
| the graph parser
std::shared_ptr< HanMacWrdKText > | m_textParser
| the text parser

## Friends

class | HanMacWrdKGraph
class | HanMacWrdKText
class | HanMacWrdKParserInternal::SubDocument

## Detailed Description

the main class to read a HanMac Word-K file

## Constructor & Destructor Documentation

## HanMacWrdKParser()

HanMacWrdKParser::HanMacWrdKParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

## ~HanMacWrdKParser()

HanMacWrdKParser::~HanMacWrdKParser | ( |  | ) |

final

destructor

## Member Function Documentation

## canSendTextAsGraphic()

bool HanMacWrdKParser::canSendTextAsGraphic | ( | long | id,
|  | long | subId )

protected

check if we can send a textzone as graphic

Referenced by HanMacWrdKParserInternal::SubDocument.

## checkHeader()

bool HanMacWrdKParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )

final virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by HanMacWrdKParserInternal::SubDocument, and parse().

## createDocument()

void HanMacWrdKParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |

protected

creates the listener which will be associated to the document

Referenced by HanMacWrdKParserInternal::SubDocument, and parse().

## createZones()

bool HanMacWrdKParser::createZones | ( |  | ) |

protected

finds the different objects zones

Referenced by HanMacWrdKParserInternal::SubDocument, and parse().

## decodeZone()

std::shared_ptr< HanMacWrdKZone > HanMacWrdKParser::decodeZone | ( | std::shared_ptr< HanMacWrdKZone > | zone | ) |

protected

try to decode a zone

Referenced by HanMacWrdKParserInternal::SubDocument, and readZone().

## getColor()

bool HanMacWrdKParser::getColor | ( | int | colId,
|  | int | patternId,
|  | MWAWColor & | color ) const

protected

returns the color associated with a pattern

Referenced by HanMacWrdKParserInternal::SubDocument.

## getPageLeftTop()

MWAWVec2f HanMacWrdKParser::getPageLeftTop | ( |  | ) | const

protected

returns the page left top point ( in inches)

Referenced by HanMacWrdKParserInternal::SubDocument.

## init()

void HanMacWrdKParser::init | ( |  | ) |

protected

inits all internal variables

Referenced by HanMacWrdKParser(), and HanMacWrdKParserInternal::SubDocument.

## newPage()

void HanMacWrdKParser::newPage | ( | int | number | ) |

protected

adds a new page

Referenced by HanMacWrdKParserInternal::SubDocument.

## parse()

void HanMacWrdKParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |

final virtual

virtual function used to parse the input

Implements MWAWTextParser.

Referenced by HanMacWrdKParserInternal::SubDocument.

## readFramesUnkn()

bool HanMacWrdKParser::readFramesUnkn | ( | std::shared_ptr< HanMacWrdKZone > | zone | ) |

protected

try to read a zone storing a list of ?

, frameType

Referenced by HanMacWrdKParserInternal::SubDocument, and readZone().

## readPrintInfo()

bool HanMacWrdKParser::readPrintInfo | ( | HanMacWrdKZone & | zone | ) |

protected

try to read a printinfo zone (type 7)

Referenced by HanMacWrdKParserInternal::SubDocument, and readZone().

## readZone()

bool HanMacWrdKParser::readZone | ( | std::shared_ptr< HanMacWrdKZone > | zone | ) |

protected

try to read a generic zone

type1: text, type7: printInfo: typed: graphic

Referenced by createZones(), and HanMacWrdKParserInternal::SubDocument.

## readZone6()

bool HanMacWrdKParser::readZone6 | ( | std::shared_ptr< HanMacWrdKZone > | zone | ) |

protected

try to read a unknown zone of type 6

Referenced by HanMacWrdKParserInternal::SubDocument, and readZone().

## readZone8()

bool HanMacWrdKParser::readZone8 | ( | std::shared_ptr< HanMacWrdKZone > | zone | ) |

protected

try to read a unknown zone of type 8

Referenced by HanMacWrdKParserInternal::SubDocument, and readZone().

## readZonea()

bool HanMacWrdKParser::readZonea | ( | std::shared_ptr< HanMacWrdKZone > | zone | ) |

protected

try to read a unknown zone of type a

Referenced by HanMacWrdKParserInternal::SubDocument, and readZone().

## readZoneb()

bool HanMacWrdKParser::readZoneb | ( | HanMacWrdKZone & | zone | ) |

protected

try to read a unknown zone of type b

Referenced by HanMacWrdKParserInternal::SubDocument, and readZone().

## readZonec()

bool HanMacWrdKParser::readZonec | ( | std::shared_ptr< HanMacWrdKZone > | zone | ) |

protected

try to read a unknown zone of type c

Referenced by HanMacWrdKParserInternal::SubDocument, and readZone().

## readZonesList()

bool HanMacWrdKParser::readZonesList | ( |  | ) |

protected

try to read the zones list

Referenced by createZones(), and HanMacWrdKParserInternal::SubDocument.

## sendText()

bool HanMacWrdKParser::sendText | ( | long | id,
|  | long | subId,
|  | MWAWListenerPtr | listener = MWAWListenerPtr() )

protected

send a text zone

Referenced by HanMacWrdKParserInternal::SubDocument.

## sendZone()

bool HanMacWrdKParser::sendZone | ( | long | zId | ) |

protected

send a zone

Referenced by HanMacWrdKParserInternal::SubDocument.

## Friends And Related Symbol Documentation

## HanMacWrdKGraph

friend class HanMacWrdKGraph

friend

Referenced by HanMacWrdKGraph, and init().

## HanMacWrdKParserInternal::SubDocument

friend class HanMacWrdKParserInternal::SubDocument

friend

## HanMacWrdKText

friend class HanMacWrdKText

friend

Referenced by HanMacWrdKText, and init().

## Member Data Documentation

## m_graphParser

std::shared_ptr<HanMacWrdKGraph> HanMacWrdKParser::m_graphParser

protected

the graph parser

Referenced by createDocument(), createZones(), getColor(), HanMacWrdKParser(), init(), parse(), readZone(), and sendZone().

## m_state

std::shared_ptr<HanMacWrdKParserInternal::State> HanMacWrdKParser::m_state

protected

the state

Referenced by checkHeader(), createDocument(), createZones(), getPageLeftTop(), HanMacWrdKParser(), init(), newPage(), and readZonesList().

## m_textParser

std::shared_ptr<HanMacWrdKText> HanMacWrdKParser::m_textParser

protected

the text parser

Referenced by canSendTextAsGraphic(), createDocument(), createZones(), HanMacWrdKParser(), init(), parse(), readZone(), and sendText().

The documentation for this class was generated from the following files:

- HanMacWrdKParser.hxx
- HanMacWrdKParser.cxx